package dev.shadowsoffire.apotheosis.adventure.socket.gem.cutting;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.adventure.Adventure;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import dev.shadowsoffire.apotheosis.adventure.affix.salvaging.SalvagingScreen;
import dev.shadowsoffire.apotheosis.adventure.client.AdventureContainerScreen;
import dev.shadowsoffire.apotheosis.adventure.client.SimpleTexButton;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemInstance;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.cutting.GemCuttingMenu;
import dev.shadowsoffire.attributeslib.api.AttributeHelper;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import java.util.ArrayList;
import java.util.List;
import java.util.function.Function;
import net.minecraft.ChatFormatting;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.components.events.GuiEventListener;
import net.minecraft.network.chat.CommonComponents;
import net.minecraft.network.chat.Component;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.ItemLike;

public class GemCuttingScreen extends AdventureContainerScreen<GemCuttingMenu> {
  public static final ResourceLocation TEXTURE = new ResourceLocation("apotheosis", "textures/gui/gem_cutting.png");
  
  protected final ItemStack displayDust = ((Item)Adventure.Items.GEM_DUST.get()).m_7968_();
  
  protected ItemStack displayMat;
  
  protected SimpleTexButton upgradeBtn;
  
  public GemCuttingScreen(GemCuttingMenu pMenu, Inventory pPlayerInventory, Component pTitle) {
    super((AbstractContainerMenu)pMenu, pPlayerInventory, pTitle);
    ((GemCuttingMenu)this.f_97732_).addSlotListener((id, stack) -> updateBtnStatus());
    this.f_97727_ = 180;
    this.f_97729_ = 5;
    this.f_97731_ = 86;
  }
  
  protected void m_7856_() {
    super.m_7856_();
    int left = getGuiLeft();
    int top = getGuiTop();
    this.upgradeBtn = (SimpleTexButton)m_142416_((GuiEventListener)(new SimpleTexButton(left + 135, top + 44, 18, 18, 238, 0, TEXTURE, 256, 256, this::clickUpgradeBtn, 

          
          (Component)Component.m_237115_("button.apotheosis.upgrade")))
        .setInactiveMessage((Component)Component.m_237115_("button.apotheosis.upgrade.no").m_130940_(ChatFormatting.RED)));
    updateBtnStatus();
  }
  
  protected void clickUpgradeBtn(Button btn) {
    this.f_96541_.f_91072_.m_105208_(((GemCuttingMenu)this.f_97732_).f_38840_, 0);
    GemUpgradeSound.start(((GemCuttingMenu)this.f_97732_).player.m_20183_());
  }
  
  protected void updateBtnStatus() {
    ItemStack gem = ((GemCuttingMenu)this.f_97732_).m_38853_(0).m_7993_();
    ItemStack left = ((GemCuttingMenu)this.f_97732_).m_38853_(1).m_7993_();
    ItemStack bot = ((GemCuttingMenu)this.f_97732_).m_38853_(2).m_7993_();
    ItemStack right = ((GemCuttingMenu)this.f_97732_).m_38853_(3).m_7993_();
    for (GemCuttingMenu.GemCuttingRecipe r : GemCuttingMenu.RECIPES) {
      if (r.matches(gem, left, bot, right)) {
        this.upgradeBtn.f_93623_ = true;
        return;
      } 
    } 
    this.displayMat = gem.m_41619_() ? ItemStack.f_41583_ : new ItemStack((ItemLike)((LootRarity)AffixHelper.getRarity(gem).get()).getMaterial());
    if (this.upgradeBtn != null)
      this.upgradeBtn.f_93623_ = false; 
  }
  
  protected void m_7286_(GuiGraphics gfx, float pPartialTick, int pMouseX, int pMouseY) {
    int xCenter = (this.f_96543_ - this.f_97726_) / 2;
    int yCenter = (this.f_96544_ - this.f_97727_) / 2;
    gfx.m_280218_(TEXTURE, xCenter, yCenter, 0, 0, this.f_97726_, this.f_97727_);
    if (hasItem(0) && GemCuttingMenu.isValidMainGem(((GemCuttingMenu)this.f_97732_).m_38853_(0).m_7993_())) {
      if (!hasItem(1))
        renderGrayItem(gfx, this.displayDust, ((GemCuttingMenu)this.f_97732_).m_38853_(1)); 
      if (!hasItem(2))
        renderGrayItem(gfx, ((GemCuttingMenu)this.f_97732_).m_38853_(0).m_7993_(), ((GemCuttingMenu)this.f_97732_).m_38853_(2)); 
      if (!hasItem(3))
        renderGrayItem(gfx, this.displayMat, ((GemCuttingMenu)this.f_97732_).m_38853_(3)); 
    } 
  }
  
  protected boolean hasItem(int slot) {
    return ((GemCuttingMenu)this.f_97732_).m_38853_(slot).m_6657_();
  }
  
  protected void renderGrayItem(GuiGraphics gfx, ItemStack stack, Slot slot) {
    SalvagingScreen.renderGuiItem(gfx, stack, getGuiLeft() + slot.f_40220_, getGuiTop() + slot.f_40221_, dev.shadowsoffire.apotheosis.adventure.client.GrayBufferSource::new);
  }
  
  protected void m_280072_(GuiGraphics gfx, int pX, int pY) {
    ItemStack gemStack = ((GemCuttingMenu)this.f_97732_).m_38853_(0).m_7993_();
    GemInstance gem = GemInstance.unsocketed(gemStack);
    GemInstance secondary = GemInstance.unsocketed(((GemCuttingMenu)this.f_97732_).m_38853_(2).m_7993_());
    List<Component> list = new ArrayList<>();
    if (gem.isValidUnsocketed()) {
      int dust = ((GemCuttingMenu)this.f_97732_).m_38853_(1).m_7993_().m_41613_();
      DynamicHolder<LootRarity> rarity = gem.rarity();
      if (rarity == RarityRegistry.getMaxRarity()) {
        list.add(Component.m_237115_("text.apotheosis.no_upgrade").m_130944_(new ChatFormatting[] { ChatFormatting.GOLD, ChatFormatting.UNDERLINE }));
      } else {
        list.add(Component.m_237115_("text.apotheosis.cut_cost").m_130944_(new ChatFormatting[] { ChatFormatting.GOLD, ChatFormatting.UNDERLINE }));
        list.add(CommonComponents.f_237098_);
        int dustCost = GemCuttingMenu.getDustCost((LootRarity)rarity.get());
        boolean hasDust = (dust > dustCost);
        list.add(Component.m_237110_("text.apotheosis.cost", new Object[] { Integer.valueOf(dustCost), ((Item)Adventure.Items.GEM_DUST.get()).m_7626_(ItemStack.f_41583_) }).m_130940_(hasDust ? ChatFormatting.GREEN : ChatFormatting.RED));
        boolean hasGem2 = (secondary.isValidUnsocketed() && gem.gem() == secondary.gem() && rarity == secondary.rarity());
        list.add(Component.m_237110_("text.apotheosis.cost", new Object[] { Integer.valueOf(1), gemStack.m_41786_().getString() }).m_130940_(hasGem2 ? ChatFormatting.GREEN : ChatFormatting.RED));
        list.add(Component.m_237115_("text.apotheosis.one_rarity_mat").m_130940_(ChatFormatting.GRAY));
        addMatTooltip(RarityRegistry.next(rarity), 1, list);
        addMatTooltip(rarity, 3, list);
        if (rarity != RarityRegistry.getMinRarity())
          addMatTooltip(RarityRegistry.prev(rarity), 9, list); 
      } 
    } 
    drawOnLeft(gfx, list, getGuiTop() + 16);
    super.m_280072_(gfx, pX, pY);
  }
  
  private void addMatTooltip(DynamicHolder<LootRarity> rarity, int cost, List<Component> list) {
    Item rarityMat = ((LootRarity)rarity.get()).getMaterial();
    ItemStack slotMat = ((GemCuttingMenu)this.f_97732_).m_38853_(3).m_7993_();
    boolean hasMats = (slotMat.m_41720_() == rarityMat && slotMat.m_41613_() >= cost);
    list.add(AttributeHelper.list().m_7220_((Component)Component.m_237110_("text.apotheosis.cost", new Object[] { Integer.valueOf(cost), rarityMat.m_7626_(ItemStack.f_41583_) }).m_130940_(!hasMats ? ChatFormatting.RED : ChatFormatting.YELLOW)));
  }
}
